"use strict";
const graphql_1 = require("graphql");
function createListType(type) {
    const nullableListType = {
        _strongType: true,
        _strongInputType: true,
        _strongOutputType: true,
        _strongValue: null,
        _weakType: () => new graphql_1.GraphQLList(type._weakType()),
        _weakInputType: () => new graphql_1.GraphQLList(type._weakInputType()),
        _weakOutputType: () => new graphql_1.GraphQLList(type._weakOutputType()),
        nullable: () => nullableListType,
    };
    const listType = {
        _strongType: true,
        _strongInputType: true,
        _strongOutputType: true,
        _strongValue: null,
        _weakType: () => new graphql_1.GraphQLNonNull(new graphql_1.GraphQLList(type._weakType())),
        _weakInputType: () => new graphql_1.GraphQLNonNull(new graphql_1.GraphQLList(type._weakInputType())),
        _weakOutputType: () => new graphql_1.GraphQLNonNull(new graphql_1.GraphQLList(type._weakOutputType())),
        nullable: () => nullableListType,
    };
    return listType;
}
exports.createListType = createListType;
